
local addon_name, addon = ...

--
-- Quest Frame
--

hooksecurefunc("QuestMapFrame_UpdateAll", function()
    for i, frame in ipairs(QuestMapFrame.QuestsFrame.Contents.Titles) do
        if not frame._alltheids_hooked then
            frame._alltheids_hooked = true
            frame:HookScript("OnEnter", function(self)
                local _, _, _, _, _, _, _, questID = GetQuestLogTitle(self.questLogIndex)
                if questID and GameTooltip:GetOwner() == self then
                    addon:AddIDLine(GameTooltip, "Quest", questID)
                end
            end)
        end
    end
end)

--
-- Reputation Frame
--

hooksecurefunc("ReputationFrame_Update", function()
    if ReputationDetailFrame:IsShown() then
        local selected = GetSelectedFaction()
        local _, _, _, _, _, _, _, _, _, _, _, _, _, factionID = GetFactionInfo(selected)
        addon:TextAppendID(ReputationDetailFactionDescription, "Faction", factionID)
    end
end)

--
-- World Map
--

hooksecurefunc("WorldMapFrame_UpdateMap", function()
    local frame = WorldMapDetailFrame
    local display = frame._alltheid_display
    if not frame._alltheid_display then
        display = frame:CreateFontString(nil, "OVERLAY")
        frame._alltheid_display = display
        display:SetFontObject(GameFontHighlightLeft)
        display:SetJustifyH("LEFT")
        display:SetHeight(24)
        display:SetWidth(128)
        display:SetPoint("BOTTOMLEFT")
    end

    display:SetText(addon:IDLine("Map", GetCurrentMapAreaID()))
end)
